/*
 * gMix open source project - https://svs.informatik.uni-hamburg.de/gmix/
 * Copyright (C) 2012  Karl-Peter Fuchs
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package evaluation.loadGenerator;

import framework.core.AnonNode;
import framework.core.config.Paths;
import framework.core.config.Settings;
import framework.core.launcher.CommandLineParameters;
import framework.core.launcher.GMixTool;
import framework.core.launcher.ToolName;


public class LoadGenerator extends GMixTool {

	public Settings settings;
	
	
	public LoadGenerator(CommandLineParameters commandLineParameters) {
		System.out.println("\nLoadGenerator started"); 
		if (commandLineParameters.globalConfigFile != null) {
			settings = new Settings(commandLineParameters.globalConfigFile);
			settings.setProperty("GLOBAL_CONFIG_MODE_ON", "TRUE");
		} else {
			settings = new Settings(Paths.PATH_TO_PATH_CONFIG_FILE);
			settings.addProperties(Paths.GENERAL_CONFIG_PROPERTY_FILE_PATH);
			settings.setProperty("GLOBAL_CONFIG_MODE_ON", "FALSE");
		}
		// loadPlugin-composition-file:
		this.settings.addProperties("./inputOutput/anonNode/pluginComposition/" + settings.getProperty("PLUG_IN_COMPOSITION"));
		if (commandLineParameters.overwriteParameters != null)
			Settings.overwriteSettings(settings.getPropertiesObject(), commandLineParameters.overwriteParameters);
		
		// TODO:
		//int num = settings.getPropertyAsInt("NUMBER_OF_PARALLEL_CONNECTIONS");
		//System.out.println("generating load for " +num +" users"); 
		commandLineParameters.gMixTool = ToolName.CLIENT;
		for (int i=0; i<1; i++)
			new AnonNode(commandLineParameters);
	}

	
	/**
	 * Comment
	 *
	 * @param args Not used.
	 */
	public static void main(String[] args) {
		CommandLineParameters params = new CommandLineParameters(args);
		params.gMixTool = ToolName.LOAD_GENERATOR;
		new LoadGenerator(params);
	}
	
}
